//
// Ό~Ǎ쐬
//
// written by T.Noda
//
// 2001/12/07 Ver 0.0.1 }ǓWJ
// 2001/12/11 Ver 0.0.2 ǓWJ
//
// D1:ǒa D2:}ǒa H: A:px
//
//
//************************************
//
//  f[^ւ
//
//************************************
procedure SwapValue(var SA : double; var EA : double);
var
  temp : double;
begin
  temp := SA;
  SA := EA;
  EA := temp;
end;
//************************************
//
//  a擾
//
//************************************
function RadiusGet(px1 : double; py1 : double; px2 : double; py2 : double; px3 : double; py3 : double) : double;
var
  L1, L2, L3 : double;
begin
  L1 := Distance(px1, py1, px2, py2);
  L2 := Distance(px2, py2, px3, py3);
  L3 := Distance(px3, py3, px1, py1);
  Result := 0.5*L2/(sin(ArcCos((L1*L1+L3*L3-L2*L2)/(2.0*L1*L3))));
end;
//************************************
//
//  SW擾
//
//************************************
procedure CenterPointGet(var x0 : double; var y0 : double; x1 : double; y1 : double; x2 : double; y2 : double; x3 : double; y3 : double);
var
  a1, a2, b1, b2, xm1, ym1, xm2, ym2, ang1, ang2 : double;
  flg1, flg2 : boolean;
begin
  xm1 := 0.5*(x1+x2);  // _擾
  ym1 := 0.5*(y1+y2);
  xm2 := 0.5*(x2+x3);
  ym2 := 0.5*(y2+y3);
  ang1 := PosToAngl(x1, y1, x2, y2)+90.0;
  if ang1 > 360.0 then
  begin
    ang1 := ang1-360.0;
  end;
  ang2 := PosToAngl(x2, y2, x3, y3)+90.0;
  if ang2 > 360.0 then
  begin
    ang2 := ang2-360.0;
  end;
  if (ang1=90.0)OR(ang1=270.0) then
  begin
    x0 := xm1;
    flg1 := true;
  end
  else
  begin
    a1 := tan(ang1);
    b1 := ym1-a1*xm1;
    flg1 := false;
  end;
  if (ang2=90.0)OR(ang2=270.0) then
  begin
    x0 := xm2;
    flg2 := true;
  end
  else
  begin
    a2 := tan(ang2);
    b2 := ym2-a2*xm2;
    flg2 := false;
  end;
  if flg1 = true then
  begin
    y0 := a2*x0+b2;
  end
  else if flg2 = true then
  begin
    y0 := a1*x0+b1;
  end
  else
  begin
    x0 := -(b2-b1)/(a2-a1);
    y0 := -(a1*b2-a2*b1)/(a2-a1);
  end;
end;
//************************************
//
//  ~ʕԕ` 2001/07/19
//
//************************************
procedure PrintArc(x1 : double; y1 : double; x2 : double; y2 : double; x3 : double; y3 : double; xm : double);
var
  x0, y0, r, SA, EA : double;
begin
  r := RadiusGet(x1, y1, x2, y2, x3, y3);
  CenterPointGet(x0, y0, x1, y1, x2, y2, x3, y3);
  SA := PosToAngl(x0, y0, x1, y1);
  EA := PosToAngl(x0, y0, x3, y3);
  if EA < SA then
    begin
      SwapValue(SA, EA);
    end;
  if Abs(EA-SA) > 180.0 then
    begin
      SwapValue(SA, EA);
    end;
  AnglCheck(SA, EA);
  Arc(x0, y0, r, SA, EA);
  x0 := 2.0*xm-x0;
  SA := 540.0-SA;
  EA := 540.0-EA;
  Arc(x0, y0, r, EA, SA);
end;
//************************************
//
//  CvO
//
//************************************
Program SLANTCROSSCYLINDER;
var
  x, y : Array of double;
  D1, D2, H, D, A : double;
  i, n : integer;

Begin
  n := 12; // 90̕ ύXƕԂׂ̍ς܂B
  AddImage(20, 20, 'Ό~PARAM.BMP');
  AddLabel(130, 20, 95, 13, 'ǒa(D1)');
  AddLabel(130, 50, 95, 13, '}ǒa(D2)');
  AddLabel(130, 80, 95, 13, '}Ǎ(H)');
  AddLabel(130, 110, 95, 13, 'px(A)');
  AddEdit(1, 230, 20, 50, 21, '');
  AddEdit(2, 230, 50, 50, 21, '');
  AddEdit(3, 230, 80, 50, 21, '');
  AddEdit(4, 230, 110, 50, 21, '');
  AddCheckBox(1, 20, 140, true, '⏕}'); // `FbN{bNX
  AddCheckBox(2, 20, 160, false, 'ǓWJ'); // `FbN{bNX
  while true do
  begin
    if ShowDlg(300, 240,'Ό~Ǎ}_CAO') <> true then
      exit;
    D1 := StrToFloat(GetDlgText(1)); // ɕϊ
    D2 := StrToFloat(GetDlgText(2));
    H := StrToFloat(GetDlgText(3));
    A := StrToFloat(GetDlgText(4));
    if (A <= 0.0) OR (A >= 180.0) OR (D1 <= 0.0) OR (D2 <= 0.0) OR (D1 < D2) OR (H <= 0.0) then
    begin
      OkMsgBox('̓f[^Ɍ肪܂B');
    end
    else
    begin
      break;
    end;
  end;
  SetArrayLength(x, 5);
  SetArrayLength(y, 5);
  Message('zuʒu͂ĉB');
  if GetPos(x[0], y[0]) = false then
  begin
    exit.
  end;
  LineType(0);  // 
  PenNo(1);     // yԍ
  if CheckBoxChecked(2) then  // ǓWJ
  begin
    if CheckBoxChecked(1) then  // ⏕
    begin
      LineType(3);  // _
      Line(x[0]-0.25*D2, y[0], x[0]+0.25*D2, y[0]);
      Line(x[0], y[0]-0.25*D2, x[0], y[0]+0.25*D2);
      LineType(0);  // 
    end
    else
    begin
      Point(x[0], y[0]);
    end;
    for i:=0 to 2*n do
    begin
      x[4] := x[0]-D1*Pi*ArcSin(0.5*D2*sin(90.0*i/n)/(0.5*D1))/360.0;
      y[4] := y[0]-tan(90.0-A)*0.5*D1*(1-cos(ArcSin(0.5*D2*sin(90.0*i/n)/(0.5*D1))))-0.5*D2*cos(90.0*i/n)/sin(A);
      if i=0 then
      begin
        x[1] := x[4];
        y[1] := y[4];
      end
      else if (i mod 2) = 1 then
      begin
        x[2] := x[4];
        y[2] := y[4];
      end
      else
      begin
        x[3] := x[4];
        y[3] := y[4];
        PrintArc(x[3], y[3], x[2], y[2], x[1], y[1], x[0]);
        x[1] := x[3];
        y[1] := y[3];
      end;
    end;
  end
  else  // }ǓWJ
  begin
    Line(x[0]-0.5*D2*Pi, y[0]+H, x[0]-0.5*D2*Pi, y[0]);
    Line(x[0]-0.5*D2*Pi, y[0], x[0]+0.5*D2*Pi, y[0]);
    Line(x[0]+0.5*D2*Pi, y[0], x[0]+0.5*D2*Pi, y[0]+H);
    for i:=0 to 2*n do
    begin
      x[4] := x[0]+0.25*D2*Pi*(2*n-i)/n;
      y[4] := y[0]+H+(0.5*D1-0.5*D1*cos(ArcSin(0.5*D2*sin(90.0*i/n)/(0.5*D1)))+(0.5*D2-0.5*D2*cos(90.0*i/n))*cos(A))/sin(A);
      if i=0 then
      begin
        x[1] := x[4];
        y[1] := y[4];
      end
      else if (i mod 2) = 1 then
      begin
        x[2] := x[4];
        y[2] := y[4];
      end
      else
      begin
        x[3] := x[4];
        y[3] := y[4];
        PrintArc(x[3], y[3], x[2], y[2], x[1], y[1], x[0]);
        x[1] := x[3];
        y[1] := y[3];
        if CheckBoxChecked(1) then
        begin
          if i < 2*n then  // ⏕`
          begin
            LineType(2);  // _
            Line(x[3], y[0], x[3], y[3]);
            Line(2.0*x[0]-x[3], y[0], 2.0*x[0]-x[3], y[3]);
            LineType(0);  // 
          end
          else
          begin
            LineType(3);  // _
            Line(x[0], y[0], x[4], y[4]);
            LineType(0);  // 
          end;
        end;
      end;
    end;
  end;
End.
